;angular.module('Landers.angular')
    .provider('LaravelEcho', function() {
        function make_echo(options){
            var opts = angular.extend({
                broadcaster: 'socket.io',
                secure: provider.secure,
                hostname: provider.hostname,
                host: provider.host,
                namespace: provider.namespace
            }, options || {});
            for (var k in opts) {
                if (opts[k] === undefined) delete opts[k];
            }
            return new Echo(opts);
        }

        var provider = this,
            global_echo,
            listeners = {};
        provider.enabled = true;
        provider.initGlobal = function(options){
            if (provider.enabled) {
                global_echo = make_echo(options);
                console.log(global_echo);
            }
        }

        this.$get = ['$http', '$timeout', function($http, $timeout){
            return {
                getGlobaEcho: function(){
                    return global_echo;
                },
                channel: function(channel){
                    return global_echo.channel(channel);
                },
                listen: function(channel, event, callback, scope) {
                    // 用$timeout, 允许在不同模块中监听同一channel
                    $timeout(function(){
                        if (!listeners[channel]) {
                            global_echo.listen(channel, event, function(data){
                                callback.call(global_echo, data);
                            });
                            listeners[channel] = true;
                            if (scope) {
                                scope.$on('$destroy', function() {
                                    listeners[channel] = false;
                                    global_echo.leave(channel);
                                });
                            }
                        }
                    }, 200);
                },
                leave: function(channel) {
                    global_echo.leave(channel);
                }
            };
        }];
    });